]> git.proxmox.com Git - mirror_qemu.git/blob - scripts/clean-includes
scripts/clean-includes: Add --all option
[mirror_qemu.git] / scripts / clean-includes
1 #!/bin/sh -e
2 #
3 # Clean up QEMU #include lines by ensuring that qemu/osdep.h
4 # is the first include listed in .c files, and no headers provided
5 # by osdep.h itself are redundantly included in either .c or .h files.
6 #
7 # Copyright (c) 2015 Linaro Limited
8 #
9 # Authors:
10 # Peter Maydell <peter.maydell@linaro.org>
11 #
12 # This work is licensed under the terms of the GNU GPL, version 2
13 # or (at your option) any later version. See the COPYING file in
14 # the top-level directory.
15
16 # Usage:
17 # clean-includes [--git subjectprefix] file ...
18 # or
19 # clean-includes [--git subjectprefix] --all
20 #
21 # If the --git subjectprefix option is given, then after making
22 # the changes to the files this script will create a git commit
23 # with the subject line "subjectprefix: Clean up includes"
24 # and a boilerplate commit message.
25 #
26 # Using --all will cause clean-includes to run on the whole source
27 # tree (excluding certain directories which are known not to need
28 # handling).
29
30 # This script requires Coccinelle to be installed.
31
32 # .c files will have the osdep.h included added, and redundant
33 # includes removed.
34 # .h files will have redundant includes (including includes of osdep.h)
35 # removed.
36 # Other files (including C++ and ObjectiveC) can't be handled by this script.
37
38 # The following one-liner may be handy for finding files to run this on.
39 # However some caution is required regarding files that might be part
40 # of the guest agent or standalone tests.
41
42 # for i in `git ls-tree --name-only HEAD` ; do test -f $i && \
43 # grep -E '^# *include' $i | head -1 | grep 'osdep.h' ; test $? != 0 && \
44 # echo $i ; done
45
46
47 GIT=no
48
49 # Extended regular expression defining files to ignore when using --all
50 XDIRREGEX='^(tests/tcg|tests/multiboot|pc-bios|disas/libvixl)'
51
52 if [ $# -ne 0 ] && [ "$1" = "--git" ]; then
53 if [ $# -eq 1 ]; then
54 echo "--git option requires an argument"
55 exit 1
56 fi
57 GITSUBJ="$2"
58 GIT=yes
59 shift
60 shift
61 fi
62
63 if [ $# -eq 0 ]; then
64 echo "Usage: clean-includes [--git subjectprefix] [--all | foo.c ...]"
65 echo "(modifies the files in place)"
66 exit 1
67 fi
68
69 if [ "$1" = "--all" ]; then
70 # We assume there are no files in the tree with spaces in their name
71 set -- $(git ls-files '*.[ch]' | grep -E -v "$XDIRREGEX")
72 fi
73
74 # Annoyingly coccinelle won't read a scriptfile unless its
75 # name ends '.cocci', so write it out to a tempfile with the
76 # right kind of name.
77 COCCIFILE="$(mktemp --suffix=.cocci)"
78
79 trap 'rm -f -- "$COCCIFILE"' INT TERM HUP EXIT
80
81 cat >"$COCCIFILE" <<EOT
82 @@
83 @@
84
85 (
86 + #include "qemu/osdep.h"
87 #include "..."
88 |
89 + #include "qemu/osdep.h"
90 #include <...>
91 )
92 EOT
93
94
95 for f in "$@"; do
96 case "$f" in
97 *.c)
98 MODE=c
99 ;;
100 *include/qemu/osdep.h | \
101 *include/qemu/compiler.h | \
102 *include/config.h | \
103 *include/standard-headers/ )
104 # Removing include lines from osdep.h itself would be counterproductive.
105 echo "SKIPPING $f (special case header)"
106 continue
107 ;;
108 *include/standard-headers/*)
109 echo "SKIPPING $f (autogenerated header)"
110 continue
111 ;;
112 *.h)
113 MODE=h
114 ;;
115 *)
116 echo "WARNING: ignoring $f (cannot handle non-C files)"
117 continue
118 ;;
119 esac
120
121 if [ "$MODE" = "c" ]; then
122 # First, use Coccinelle to add qemu/osdep.h before the first existing include
123 # (this will add two lines if the file uses both "..." and <...> #includes,
124 # but we will remove the extras in the next step)
125 spatch --in-place --no-show-diff --cocci-file "$COCCIFILE" "$f"
126
127 # Now remove any duplicate osdep.h includes
128 perl -n -i -e 'print if !/#include "qemu\/osdep.h"/ || !$n++;' "$f"
129 else
130 # Remove includes of osdep.h itself
131 perl -n -i -e 'print if !/\s*#\s*include\s*(["<][^>"]*[">])/ ||
132 ! (grep { $_ eq $1 } qw ("qemu/osdep.h"))' "$f"
133 fi
134
135 # Remove includes that osdep.h already provides
136 perl -n -i -e 'print if !/\s*#\s*include\s*(["<][^>"]*[">])/ ||
137 ! (grep { $_ eq $1 } qw (
138 "config-host.h" "qemu/compiler.h" "config.h"
139 <stdarg.h> <stddef.h> <stdbool.h> <stdint.h> <sys/types.h>
140 <stdlib.h> <stdio.h> <string.h> <strings.h> <inttypes.h>
141 <limits.h> <unistd.h> <time.h> <ctype.h> <errno.h> <fcntl.h>
142 <sys/stat.h> <sys/time.h> <assert.h> <signal.h>
143 "glib-compat.h" "qapi/error.h"
144 ))' "$f"
145
146 done
147
148 if [ "$GIT" = "yes" ]; then
149 git add -- "$@"
150 git commit --signoff -F - <<EOF
151 $GITSUBJ: Clean up includes
152
153 Clean up includes so that osdep.h is included first and headers
154 which it implies are not included manually.
155
156 This commit was created with scripts/clean-includes.
157
158 EOF
159
160 fi